
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <cstdlib>
#include <cstring>
using namespace std;
#define FI first
#define SE second
#define X first
#define Y second
#define ST first
#define ND second
#define MP make_pair
#define PB push_back
typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long LL;
typedef long double LD;
typedef double D;
#define REP(i,n) for(int i=0;i<(n);i++)
#define FOR(i,a,b) for(int i=(a);i<=(b);i++)
#define FORD(i,a,b) for(int i=(a);i>=(b);i--)
#define FORE(a,b) for(VAR(a,(b).begin());a!=(b).end();a++)
#define VAR(a,b) __typeof(b) a=(b)
#define SIZE(a) ((int)(a).size())
#define ALL(x) (x).begin(),(x).end()
#define CLR(x,a) memset(x,a,sizeof(x))

struct Path;

struct Bucket {
    bool reversed;

    vector<int> elements;

    Path* owner;

    Bucket() {
        reversed = false;
    }

    void normalize() {
        if (reversed) {
            reversed = false;
            std::reverse(ALL(elements));
        }
    }
};

struct Path {
    vector<Bucket*> buckets;

    void reverse() {
        std::reverse(ALL(buckets));
        FORE (it, buckets) {
            (*it)->reversed ^= 1;
        }
    }
};

Bucket** myBucket;

int posInBucket(int v) {
    int res = 0;
    FORE (it, myBucket[v]->elements) {
        if (*it == v) {
            return res;
        }
        ++res;
    }
    return -1;
}

int posOnPath(int v) {
    int res = 0;
    FORE (it, myBucket[v]->owner->buckets) {
        if (*it == myBucket[v]) {
            return res + posInBucket(v);
        }
        res += (*it)->elements.size();
    }
    return -1;
}

void joinBuckets(Bucket* l, Bucket* r) {
    l->normalize();
    r->normalize();
    FORE (it, r->elements) {
        l->elements.PB(*it);
        myBucket[*it] = l;
    }
    delete r;
}

int mxLen = 70;

void joinPaths(Path* l, Path* r) {
    if ((int) l->buckets.back()->elements.size() < mxLen && (int) r->buckets[0]->elements.size() < mxLen) {
        joinBuckets(l->buckets.back(), r->buckets[0]);
        r->buckets.erase(r->buckets.begin());
    }
    FORE (it, r->buckets) {
        (*it)->owner = l;
        l->buckets.PB(*it);
    }
    delete r;
}

Bucket* splitBucket(Bucket* b, int el) {
    Bucket* res = new Bucket;
    res->owner = b->owner;
    for (int i = el; i < (int) b->elements.size(); ++i) {
        myBucket[b->elements[i]] = res;
        res->elements.PB(b->elements[i]);
    }
    b->elements.erase(b->elements.begin() + el, b->elements.end());
    return res;
}

Path* splitPath(Path* p, int el) {
    Path* res = new Path;
    int c = 0;
    int sum = 0;
    while (sum < el) {
        sum += p->buckets[c]->elements.size();
        ++c;
    }
    if (sum > el) {
        Bucket* nx = splitBucket(p->buckets[c - 1], sum - el);
        nx->owner = res;
        res->buckets.PB(nx);
    }
    for (int i = c; i < (int) p->buckets.size(); ++i) {
        p->buckets[i]->owner = res;
        res->buckets.PB(p->buckets[i]);
    }
    p->buckets.erase(p->buckets.begin() + c, p->buckets.end());
    return res;
}

bool together(int a, int b) {
    return myBucket[a]->owner == myBucket[b]->owner;
}

void addEdge(int a, int b) {
    int pa = posOnPath(a), pb = posOnPath(b);
    if (pa == 0) {
        myBucket[a]->owner->reverse();
    }
    if (pb != 0) {
        myBucket[b]->owner->reverse();
    }
    joinPaths(myBucket[a]->owner, myBucket[b]->owner);
}

void removeEdge(int a, int b) {
    int pa = posOnPath(a), pb = posOnPath(b);
    if (pa > pb) {
        swap(a, b);
        swap(pa, pb);
    }
    splitPath(myBucket[a]->owner, pb);
}

const int N = 8005;

vector<int>* e;
bool vis[N];

int n;

void construct() {
    for (int i = 1; i <= n; ++i) {
        vis[i] = false;
    }
    for (int i = 1; i <= n; ++i) {
        if (e[i].size() < 2 && !vis[i]) {
            Path* curPath = new Path;
            Path* lastBucket = new Bucket;
            int c = i;
            while (true) {
                vis[c] = true;
                myBucket[c] = lastBucket;
                lastBucket->elements.PB(c);
                int nx = -1;
                FORE (it, e[c]) {
                    if (!vis[*it]) {
                        nx = *it;
                    }
                }
                if (nx == -1) {
                    break;
                }
                if (lastBucket->elements.size() > 2 * mxLen) {
                    lastBucket->owner = curPath;
                    curPath->buckets.PB(lastBucket);
                    lastBucket = new Bucket;
                }
                c = nx;
            }
        }
    }
}

map<PII, int> edgeOwner;
vector<int> edges[105][8005];
Bucket* buckets[105][8005];

int m, c, t;

void alg() {
    scanf("%d %d %d", &m, &c, &t);
    for (int i = 1; i <= m; ++i) {
        int a, b, own;
        scanf("%d %d %d", &a, &b, &own);
        if (a > b) {
            swap(a, b);
        }
        edgeOwner[MP(a, b)] = own;
        edges[own][a].PB(b);
        edges[own][b].PB(a);
    }
    for (int i = 1; i <= c; ++i) {
        myBucket = buckets[i];
        e = edges[i];
        construct();
    }
}

int main() {
    while (scanf("%d", &n) != EOF && n != 0) {
        alg();
    }

  return 0;
}

